datablock AudioProfile(FjetBomberFireSound)
{
   filename    = "base/data/sound/playermount.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(FjetBomberExplodeSound)
{
   filename    = "./FjetBomberHit.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(FjetBomberLoopSound)
{
   filename    = "./bombfall.wav";
   description = AudioDefault3d;
   preload = true;
};

//trail
datablock ParticleData(FjetBomberTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 100;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/thinring";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1.0 1.0 1.0 1.0";
	colors[1]	= "0.8 0.8 0.8 0.0";
	sizes[0]	= 0.6;
	sizes[1]	= 0.2;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(FjetBomberTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = FjetBomberTrailParticle;

   useEmitterColors = true;
   uiName = "";
};


datablock ParticleData(FjetBomberExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 3000;
	lifetimeVarianceMS   = 000;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	colors[0]     = "0.2 0.12 0.1 1";
	colors[1]     = "0.22 0.2 0.2 0.4";
	colors[2]     = "0.3 0.3 0.3 0.0";
	sizes[0]      = 7.0;
	sizes[1]      = 10.0;
	sizes[2]      = 20.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(FjetBomberExplosionEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FjetBomberExplosionParticle";

   useEmitterColors = true;
   uiName = "";
};

datablock ExplosionData(FjetBomberExplosion)
{
   //explosionShape = "";
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
	soundProfile = FjetBomberExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = FjetBomberExplosionEmitter;
   particleDensity = 12;
   particleRadius = 2;

   faceViewer     = true;
   explosionScale = "2 2 2";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 25;
   lightStartColor = "1.0 0.6 0.2 1";
   lightEndColor = "1 1 0 0";

   damageRadius = 20;
   radiusDamage = 2000;

   impulseRadius = 10;
   impulseForce = 4000;
};



AddDamageType("FjetBomber",   '<bitmap:add-ons/vehicle_FighterJet/CI_FJETbomber> %1',    '%2 <bitmap:add-ons/vehicle_FighterJet/CI_FJETbomber> %1',0.2,1);

datablock ProjectileData(FjetBomberProjectile)
{
   projectileShapeName = "./FjetBombprojectile.dts";
   directDamage        = 6000;
   directDamageType    = $DamageType::FjetBomber;
   radiusDamageType    = $DamageType::FjetBomber;

   brickExplosionRadius = 8;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground

   sound = FjetBomberLoopSound;

   impactImpulse	     = 750;
   verticalImpulse	  = 750;
   explosion           = FjetBomberExplosion;
   particleEmitter     = FjetBomberTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   muzzleVelocity      = 95;
   velInheritFactor    = 5;

   armingDelay         = 00;
   lifetime            = 9000;
   fadeDelay           = 8900;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 7.0;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "1.0 0.7 0.2 1";

   uiName = "";
};
