datablock AudioProfile(FjetMGFireSound)
{
   filename    = "./FjetMGShot.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(FjetMGExplodeSound)
{
   filename    = "./FjetMGHit.wav";
   description = AudioDefault3d;
   preload = true;
};

//trail
datablock ParticleData(FjetMGTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 20;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/thinring";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1.0 0.9 0.7 1.0";
	colors[1]	= "0.2 0.2 0.2 0.0";
	sizes[0]	= 0.3;
	sizes[1]	= 0.2;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(FjetMGTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = FjetMGTrailParticle;

   useEmitterColors = true;
   uiName = "";
};


datablock ParticleData(FjetMGExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 000;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	colors[0]     = "0.2 0.12 0.1 1";
	colors[1]     = "0.22 0.2 0.2 0.4";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;


	useInvAlpha = true;
};
datablock ParticleEmitterData(FjetMGExplosionEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FjetMGExplosionParticle";

   useEmitterColors = true;
   uiName = "";
};

datablock ExplosionData(FjetMGExplosion)
{
   explosionShape = "";
	soundProfile = FjetMGExplodeSound;

   lifeTimeMS = 50;

   particleEmitter = FjetMGExplosionEmitter;
   particleDensity = 2;
   particleRadius = 0.25;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;

   // Dynamic light

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0;
   impulseForce = 1;
};



AddDamageType("FjetMG",   '<bitmap:add-ons/vehicle_FighterJet/CI_FJET> %1',    '%2 <bitmap:add-ons/vehicle_FighterJet/CI_FJET> %1',0.2,1);

datablock ProjectileData(FjetMGProjectile)
{
   projectileShapeName = "./FjetMGprojectile.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::FjetMG;
   radiusDamageType    = $DamageType::FjetMG;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 5;
   verticalImpulse	  = 5;
   explosion           = FjetMGExplosion;
   particleEmitter     = FjetMGTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   muzzleVelocity      = 500;
   velInheritFactor    = 2;

   armingDelay         = 00;
   lifetime            = 6000;
   fadeDelay           = 5500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 0.5;
   lightColor  = "1.0 0.7 0.2 1";

   uiName = "";
};
