datablock ParticleData(FJetStreamParticle)
{
   dragCoefficient      = 0;
   windCoefficient     = 0.2;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   useInvAlpha = true;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 250;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/cloud";
   colors[0]     = "1.0 0.6 0.4 0.12";
   colors[1]     = "0.75 0.75 0.7 0.06";
   colors[2]     = "1.0 1.0 1.0 0";
   sizes[0]      = 1;
   sizes[1]      = 2;
   sizes[2]      = 1;
   times[0]      = 0.0;
   times[1]      = 0.25;
   times[2]      = 1;


};

datablock ParticleEmitterData(FJetStreamEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FJetStreamParticle";
};

datablock ShapeBaseImageData(FJetStreamImage1)
{
   shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 8;
   rotation = "1 0 0 -90";

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 10000;
	stateEmitter[1]					= FJetStreamEmitter;
	stateEmitterTime[1]				= 10000;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};
function FJetStreamImage1::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}
datablock ShapeBaseImageData(FJetStreamImage2)
{
   	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 9;
   	rotation = "1 0 0 -90";

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]		= "Done";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 10000;
	stateEmitter[1]					= FJetStreamEmitter;
	stateEmitterTime[1]				= 10000;

	stateName[2]					= "Done";
	stateScript[2]					= "onDone";
};
function FJetStreamImage2::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

function FJetStreamCheck(%obj)
{
//	return;
	if(!isObject(%obj))
		return;

	%speed = vectorLen(%obj.getVelocity());
	if(%speed < %obj.dataBlock.minFJetStreamSpeed)
	{
		if(%obj.getMountedImage(3) !$= "")
		{
			%obj.unMountImage(2);
			%obj.unMountImage(3);
		}
	}
	else
	{
		if(%obj.getMountedImage(3) $= 0)
		{
			%obj.mountImage(FJetStreamImage1,2);
			%obj.mountImage(FJetStreamImage2,3);
		}
	}

	schedule(2000,0,"FJetStreamCheck",%obj);
}