datablock AudioProfile(HMissileFireSound)
{
   filename    = "./HMissileShot.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(HMissileExplodeSound)
{
   filename    = "./HMissileHit.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(HMissileLoopSound)
{
   filename    = "./HMissileLoop.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

//trail
datablock ParticleData(HomingMissileTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 150;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1.0 0.6 0.2 1.0";
	colors[1]	= "0.8 0.8 0.8 0.0";
	sizes[0]	= 0.6;
	sizes[1]	= 0.4;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(HomingMissileTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = HomingMissileTrailParticle;

   useEmitterColors = true;
   uiName = "";
};


datablock ParticleData(HomingMissileExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 000;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	colors[0]     = "0.2 0.12 0.1 1";
	colors[1]     = "0.22 0.2 0.2 0.4";
	colors[2]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 7.0;
	sizes[1]      = 10.0;
	sizes[2]      = 15.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(HomingMissileExplosionEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HomingMissileExplosionParticle";

   useEmitterColors = true;
   uiName = "";
};

datablock ExplosionData(HomingMissileExplosion)
{
   //explosionShape = "";
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
	soundProfile = HMissileExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = HomingMissileExplosionEmitter;
   particleDensity = 9;
   particleRadius = 0.5;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 15;
   lightStartColor = "1.0 0.6 0.2 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 10;
   radiusDamage = 2000;

   impulseRadius = 4;
   impulseForce = 4000;
};



AddDamageType("HomingMissile",   '<bitmap:add-ons/vehicle_FighterJet/CI_FJETmissile> %1',    '%2 <bitmap:add-ons/vehicle_FighterJet/CI_FJETmissile> %1',0.2,1);

datablock ProjectileData(HomingMissileProjectile)
{
   projectileShapeName = "./homingmissileprojectile.dts";
   directDamage        = 6000;
   directDamageType    = $DamageType::HomingMissile;
   radiusDamageType    = $DamageType::HomingMissile;

   brickExplosionRadius = 6;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground

   sound = HMissileLoopSound;

   impactImpulse	     = 750;
   verticalImpulse	  = 750;
   explosion           = HomingMissileExplosion;
   particleEmitter     = HomingMissileTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   muzzleVelocity      = 75;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 7500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = True;
   lightRadius = 5.0;
   lightColor  = "1.0 0.7 0.2 1";

   uiName = "";
};


package HomingMissile
{
	function Projectile::onAdd(%obj,%a,%b)
	{
		Parent::onAdd(%obj,%a,%b);
		if(%obj.dataBlock.getID() == homingMissileProjectile.getID())
		{
			if(!%obj.doneHomingDelay)
				%obj.schedule(300,spawnHomingMissile);
			else
				%obj.schedule(75,spawnHomingMissile);
		}
	}
};activatePackage(HomingMissile);

function Projectile::spawnHomingMissile(%this)
{
	if(!isObject(%this.client))
		return;
	
	if(!isObject(%this) || vectorLen(%this.getVelocity()) == 0)
		return;
		
	%client = %this.client;
	%muzzle = vectorLen(%this.getVelocity());
	
	if(!isObject(%this.target) || %this.target.getState() $= "Dead" || %this.target.getMountedImage(0) == adminWandImage.getID() || vectorDist(%this.getPosition(),%this.target.getHackPosition()) > 30)
	{
		%pos = %this.getPosition();
		%radius = 600;
		%searchMasks = $TypeMasks::PlayerObjectType;
		InitContainerRadiusSearch(%pos, %radius, %searchMasks);
		%minDist = 1000;
		while ((%searchObj = containerSearchNext()) != 0 )
		{
			if((miniGameCanDamage(%client,%searchObj)) == 1)
			{
				if(%searchObj.getState() $= "Dead")
					continue;
				
				//if(%client == %searchObj.client)
				if(%this.sourceObject == %searchObj)
					continue;
				
				if(isTeamFriendly(%this,%searchObj) != 0)
					continue;
				
				if(%searchObj.getMountedImage(0) == adminWandImage.getID())
					continue;
				
				if(%searchObj.isCloaked)
					continue;
				
				%d = vectorDist(%pos,%searchObj.getPosition());
				if(%d < %minDist)
				{
					%minDist = %d;
					%found = %searchObj;
				}
			}
		}
		
		if(isObject(%found))
			%this.target = %found;
		else
		{
			%this.schedule(150,spawnHomingMissile);
			return;
		}
	}
	
	%found = %this.target;
	
	%pos = %this.getPosition();
	%start = %pos;
	%end = %found.getHackPosition();
	%enemypos = %end;
	%vec = vectorNormalize(vectorSub(%end,%start));
	for(%i=0;%i<5;%i++)
	{
		%t = vectorDist(%start,%end) / vectorLen(vectorScale(getWord(%vec,0) SPC getWord(%vec,1),%muzzle));
		%velaccl = vectorScale(%accl,%t);
		
		%x = getword(%velaccl,0);
		%y = getword(%velaccl,1);
		%z = getWord(%velaccl,2);
		
		%x = (%x < 0 ? 0 : %x);
		%y = (%y < 0 ? 0 : %y);
		%z = (%z < 0 ? 0 : %z);
		
		%vel = vectorAdd(vectorScale(%found.getVelocity(),%t),%x SPC %y SPC %z);
		%end = vectorAdd(%enemypos,%vel);
		%vec = vectorNormalize(vectorSub(%end,%start));
	}
	
	%addVec = vectorAdd(%this.getVelocity(),vectorScale(%vec,180/vectorDist(%pos,%end)*(%muzzle/40)));
	%vec = vectorNormalize(%addVec);
	
	%p = new Projectile()
	{
		dataBlock = %this.dataBlock;
		initialPosition = %pos;
		initialVelocity = vectorScale(%vec,%muzzle);
		sourceObject = %this.sourceObject;
		client = %this.client;
		sourceSlot = 0;
		originPoint = %this.originPoint;
		doneHomingDelay = 1;
		target = %this.target;
		reflectTime = %this.reflectTime;
	};
	
	if(isObject(%p))
	{
		MissionCleanup.add(%p);
		%p.setScale(%this.getScale());
		%this.delete();
	}
}

function isTeamFriendly(%obj1,%obj2)
{
	// 0 = enemy
	// 1 = allied
	//-1 = neutral
	%mini1 = getMinigameFromObject(%obj1);
	%mini2 = getMinigameFromObject(%obj2);
	if(%mini1 != %mini2)
		return -1;
	
	if(!isObject(%mini1))
		return -1;
	
	if(%obj1 == %obj2)
		return 1;
	
	//With Team Deathmatch, players on different TDM teams are enemies, as well as those in team -1 (neutral)
	%usingTDM = (isObject(GameModeStorerSO) && GameModeStorerSO.modeUsesTeams[%mini1.gamemode]);
	
	//With either zombie mod, players that are on a zombies team and players that aren't are enemies (handily both are "player.isZombie")
	
	//Iban's zombies will never run with Team Deathmatch
	%usingIbanZombies = ($ZAPT::Version > 0 && miniGameUsingTDMGameMode(%mini1) && %mini1.ZAPT_enabled);
	
	//Rotondo's zombies can - if enabled, players on a neutral TDM team are allied.
	%usingRotZombies = ($pref::Server::ZombiesEnabled && %mini1.EnableZombies);
	
	switch$(%obj1.getClassName())
	{
		case "Player":
			%cl1 = %obj1.client;
			%zombie1 = (%usingIbanZombies && %obj1.isZombie);
		case "AIPlayer":
			%zombie1 = %obj1.isZombie;
			if(isObject(%obj1.client))
				%cl1 = %obj1.client;
			else if(isObject(%obj1.spawnBrick) && %usingTDM)
				%team1 = %obj1.spawnBrick.tdmAlliedTeam-1;
		case "Projectile":
			%zombie1 = (isObject(%obj1.sourceObject) && (%obj1.sourceObject.getType() & $TypeMasks::PlayerObjectType) && %obj1.sourceObject.isZombie);
			%cl1 = %obj1.client;
		case "GameConnection":
			%zombie1 = (%obj1.player.isZombie);
			%cl1 = %obj1;
		case "AIConnection":
			%zombie1 = (%obj1.player.isZombie);
			%cl1 = %obj1;
		default:
			return -1;
	}
	
	if(%usingTDM && %tdmTeam1 $= "" && isObject(%cl1))
		%team1 = %cl1.tdmTeam;
	
	switch$(%obj2.getClassName())
	{
		case "Player":
			%cl2 = %obj2.client;
			%zombie2 = (%usingIbanZombies && %obj2.isZombie);
		case "AIPlayer":
			%zombie2 = %obj2.isZombie;
			if(isObject(%obj2.client))
				%cl2 = %obj2.client;
			else if(isObject(%obj2.spawnBrick) && %usingTDM)
				%team2 = %obj2.spawnBrick.tdmAlliedTeam-1;
		case "Projectile":
			%zombie2 = (isObject(%obj2.sourceObject) && (%obj2.sourceObject.getType() & $TypeMasks::PlayerObjectType) && %obj2.sourceObject.isZombie);
			%cl2 = %obj2.client;
		case "GameConnection":
			%zombie2 = (%obj2.player.isZombie);
			%cl2 = %obj2;
		case "AIConnection":
			%zombie2 = (%obj2.player.isZombie);
			%cl2 = %obj2;
		default:
			return -1;
	}
	
	if(%usingTDM && %tdmTeam2 $= "" && isObject(%cl2))
		%team2 = %cl2.tdmTeam;
	
	//echo(%team1 SPC %team2);
	
	if(%usingTDM && %team1 == %team2)
	{
		if(%team1 == -1)
			return %usingRotZombies;
		
		return 1;
	}
	
	if(%usingIbanZombies || %usingRotZombies)
		return (%zombie1 == %zombie2);
	
	return 0;
}