//trail
datablock ParticleData(MissileTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 170;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= True;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1.0 0.8 0.4 1.0";
	colors[1]	= "0.3 0.3 0.3 0.0";
	sizes[0]	= 0.6;
	sizes[1]	= 0.4;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(MissileTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = MissileTrailParticle;

   useEmitterColors = true;
   uiName = "";
};


AddDamageType("Missile",   '<bitmap:add-ons/vehicle_FighterJet/CI_FJETmissile> %1',    '%2 <bitmap:add-ons/vehicle_FighterJet/CI_FJETmissile> %1',0.2,1);

datablock ProjectileData(MissileProjectile)
{
   projectileShapeName = "./Missileprojectile.dts";
   directDamage        = 4000;
   directDamageType    = $DamageType::Missile;
   radiusDamageType    = $DamageType::Missile;

   brickExplosionRadius = 6;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground

   sound = HMissileLoopSound;

   impactImpulse	     = 750;
   verticalImpulse	  = 750;
   explosion           = HomingMissileExplosion;
   particleEmitter     = MissileTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   muzzleVelocity      = 85;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 8000;
   fadeDelay           = 7500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = True;
   lightRadius = 5.0;
   lightColor  = "1.0 0.7 0.2 1";

   uiName = "";
};
