datablock WheeledVehicleData(HFighterjetVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./Fighterjet.dts";
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 1;
   mountThread[0] = "sit";



	maxDamage = 200.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 200.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 25;         // Far distance from vehicle
	cameraOffset = 7;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire   = FighterjetTire;
	defaultSpring   = FighterjetSpring;
	// flatTire	   = FighterjetFlatTire;
	// flatSpring	   = FighterjetFlatSpring;

   numWheels = 4;

	// Rigid Body
	mass = 200;
	density = 5.0;
	drag = 0.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 25;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 8000; //8000;       // Engine power
	engineBrake = 6000;         // Braking when throttle is 0
	brakeTorque = 8000;        // When brakes are applied
	maxWheelSpeed = 15;        // Engine scale by current speed / max speed

	rollForce		= 1500;
	yawForce		= 600;
	pitchForce		= 400;
	rotationalDrag		= 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

   isSled = false;

   forwardThrust		= 5000;
	reverseThrust		= 2000;
	lift			= 100;
	maxForwardVel		= 60;
	maxReverseVel		= 5;
	horizontalSurfaceForce	= 150;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
	verticalSurfaceForce	= 160; 
	rollForce		= 20000;
	yawForce		= 11000;
	pitchForce		= 12000;
	rotationalDrag		= 0.5;
	stallSpeed		= 5;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Fighter Jet-Homing Missiles";
	rideable = true;
		lookUpLimit = 0.50;
		lookDownLimit = 0.50;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = FighterjetExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 10000;

   finalExplosionProjectile = FighterjetFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 5;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 15;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 3.2; //how hard a person you're running over gets pushed
   
      // Advanced Steering
   steeringAutoReturn = false;
   // steeringAutoReturnRate = 0.9;
   // steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = false;
   // steeringStrafeSteeringRate = 0.1;
   
   minFJetStreamSpeed = 30;

ShootOnClick=1;
ShootOnClick_Hold=0;
ShootOnClick_ShootDelay=4000;
ShootOnClick_ReShootDelay=4000;
ShootOnClick_ProjectileCount=2;
ShootOnClick_RequiredSlot=0;
ShootOnClick_Sound=HMissileFIRESound;

ShootOnClick_Projectile[0]=HomingMissileProjectile;
ShootOnClick_Position[0]="0 2.8 -1";
ShootOnClick_Velocity[0]="140 0 0";
ShootOnClick_Scale[0]="1 1 1";

ShootOnClick_Projectile[1]=HomingMissileProjectile;
ShootOnClick_Position[1]="0 -2.8 -1";
ShootOnClick_Velocity[1]="140 0 0";
ShootOnClick_Scale[1]="1 1 1";
};

function HFighterjetvehicle::onadd(%this,%obj)
{ 
	
	parent::onadd(%this,%obj);
	   %obj.playThread(0,"propfast");

	FJetStreamCheck(%obj);
	    
}